%Ejemplo de fit

% Primero cargamos los datos:
load 'datos.mat'

% graficamos los datos
eb=errorbar(xx,yy,errores)
set(eb,'linestyle','none')
set(eb,'marker','.')
set(eb,'markersize',15)
set(eb,'linewidth',3)
xlabel('xx')
ylabel('yy')


% Ensayamos algunos valores "a mano" para el modelo 1
A=1.5;
x0=0;
w=4;
y0=1.5;
parametros1=[A, x0, w, y0];
ff1=modelo1(xx,parametros1);

% Los graficamos **********************************************************
eb=errorbar(xx,yy,errores);
set(eb,'linestyle','none')
set(eb,'marker','.')
set(eb,'markersize',15)
set(eb,'linewidth',2)
hold on
p=plot(xx,ff1,'r-');
set(p,'linewidth',2)

hold off
xlabel('xx')
ylabel('yy')
title('modelo1')
% print ("ej_modelo1.png", "-color", "-FHelvetica:12", "-dpng")

% *************************************************************************

disp('Presionar una tecla para continuar')
pause

% Ensayamos algunos valores "a mano" para el modelo 2 *********************
A=1.5;
x0=0;
w=2;
y0=1.5;
parametros2=[A, x0, w, y0];
ff2=modelo2(xx,parametros2);

eb=errorbar(xx,yy,errores);
set(eb,'linestyle','none')
set(eb,'marker','.')
set(eb,'markersize',15)
set(eb,'linewidth',2)
hold on
p=plot(xx,ff2,'r-');
set(p,'linewidth',2)

hold off
xlabel('xx')
ylabel('yy')
title('modelo2')
% print ("ej_modelo2.png", "-color", "-FHelvetica:12", "-dpng")

% *************************************************************************

disp('Presionar una tecla para continuar')
pause

% Realizamos el fiteo:

pesos=1./errores;


[f1,p1,cvg1,iter1,corp1,covp1]=leasqr(xx,yy,parametros1,'modelo1',.0001,20,pesos);


[f2,p2,cvg2,iter2,corp2,covp2]=leasqr(xx,yy,parametros2,'modelo2',.0001,20,pesos);


% Grafico de los modelos fiteados *****************************************
eb=errorbar(xx,yy,errores)
set(eb,'linestyle','none')
set(eb,'marker','.')
set(eb,'markersize',15)
set(eb,'linewidth',2)
hold on

p=plot(xx,f1,'r-',xx,f2,'g-');
set(p,'linewidth',2)

hold off
legend('datos','modelo1','modelo2','location','west')
xlabel('xx')
ylabel('yy')
title('Fit final')
% print ("fit_final.png", "-color", "-FHelvetica:12", "-dpng")

% *************************************************************************

% Analicemos que tan buenos son los fiteos


parametros1
p1'

parametros2
p2'

chi2_modelo1=sum( (yy-f1).^2 )
chi2_modelo2=sum( (yy-f2).^2 )

r2_modelo1=corr(yy,f1)^2
r2_modelo2=corr(yy,f2)^2


disp('Presionar una tecla para continuar')
pause


% Grafico de los modelos fiteados por separado ****************************
subplot(2,2,1)  % Fit modelo 1
    eb=errorbar(xx,yy,errores)
    set(eb,'linestyle','none')
    set(eb,'marker','.')
    set(eb,'markersize',5)
    set(eb,'linewidth',2)
    hold on

    p=plot(xx,f1,'r-');
    set(p,'linewidth',2)

    hold off
    xlabel('xx')
    ylabel('yy')
    title('Modelo 1')
    grid()


subplot(2,2,2)  % Fit modelo 2
    eb=errorbar(xx,yy,errores)
    set(eb,'linestyle','none')
    set(eb,'marker','.')
    set(eb,'markersize',5)
    set(eb,'linewidth',2)
    hold on

    p=plot(xx,f2,'g-');
    set(p,'linewidth',2)

    hold off
    xlabel('xx')
    ylabel('yy')
    title('Modelo 2')
    grid()


subplot(2,2,3)  % Residuos modelo 1
    p=plot(xx,f1-yy,'-');
    set(p,'linewidth',2)
    xlabel('xx')
    ylabel('yy')
    title('Residuos modelo 1')
    grid()
    ylim([-0.2,0.2])


subplot(2,2,4)  % Residuos modelo 2
    p=plot(xx,f2-yy,'-');
    set(p,'linewidth',2)
    xlabel('xx')
    ylabel('yy')
    title('Residuos modelo 2')
    grid()
    ylim([-0.2,0.2])



% *************************************************************************

